#ifndef __fsm_h
#define __fsm_h
#include "/usr/local/filedv2/shmem.h"

/* 
 * the filed_shmem package is intended to be linked against
 * samba. 
 * it has two major functions, notify and translate
 * fsm_notify() will notify filed of access on a file
 * fsm_translate() will return a translated filename
 * in addition, fsm_notify() returns a 1 if the file
 * is in filed's translation table or a 0 if not
 * there is one more function,fsm_quiet_translate(), which 
 * performs the translation but does not notify filed
 * all of these functions call on the external struct
 * fsm
 */

/* 
 * This library also has an initilizer function,
 * fsm_init(). This is called with the shared memory key of 
 * the shared memory segment 
 */

struct fsm {
	struct msg *msg;
	int shmkey;
};

void fsm_init(int shared_memory_key);
char *fsm_translate(char *file);
char *fsm_map(char *file);
int fsm_notify(char *file);
	
extern struct fsm *fsm;

#endif
