#include "log.h"
#include "flags.h"
#include "filed.h"
#include "externs.h"
#include "socket.h"
#include "io.h"
#include <syslog.h>
#include <stdarg.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>


void elog(char *message, ...) {
        va_list ap;
        char buf[4096];
	char out[4096];

        va_start(ap,message);
        vsprintf(buf,message,ap);
        va_end(ap);
	if(errno) {
		sprintf(out,"%s: %s",buf,strerror(errno)); 
		errno = 0;
	} else sprintf(out,"%s",buf);

        syslog(LOG_CRIT,out);
	if(sys_flags & FLAG_CONSOLE_WRITE)
     	   printf("%s\n",out);
}

void dlog(int logtype, char *message, ...) {
        va_list ap;
        char buf[4096];
	char out[4096];
	struct connection *c = filed->con_head;
	int found;


        va_start(ap,message);
        vsprintf(buf,message,ap);
        va_end(ap);

	if(errno) {
		sprintf(out,"[%d] %s: %s (%d)",getpid(),buf,strerror(errno),errno);
		errno = 0;
	} else sprintf(out,"[%d] %s",getpid(),buf);
	
	
	if(sys_flags & FLAG_DEBUGGING) {
		while(c) {
			if(c->type == CTYPE_HUMAN) {
				if(c->debug_mask) found++;
				if(c->debug_mask & logtype) c_send(c,out);
			}
			c = c->next;
		}
		if(!found) sys_flags -= FLAG_DEBUGGING;
	}

        if(debug & logtype) syslog(LOG_DEBUG,out);
        if(debug && (sys_flags & FLAG_CONSOLE_WRITE))
	        printf("%s\n",out);
}
